HDU 1312 Red and Black

来源:互联网 发布:2015刷q币软件 编辑:程序博客网 时间:2024/05/16 19:08

看了好多天的DFS,基本上的程序都是要借助解题报告才可以实现

但是这一题,确实依照自己的思路,完全靠自己写出来的,或许比较简单吧,所以特此发表下文章,犒劳一下自己,再接再厉

http://acm.hdu.edu.cn/showproblem.php?pid=1312

Red and Black

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 2364    Accepted Submission(s): 1551


Problem Description
There is a rectangular room, covered with square tiles. Each tile is colored either red or black. A man is standing on a black tile. From a tile, he can move to one of four adjacent tiles. But he can't move on red tiles, he can move only on black tiles.

Write a program to count the number of black tiles which he can reach by repeating the moves described above.
 

Input
The input consists of multiple data sets. A data set starts with a line containing two positive integers W and H; W and H are the numbers of tiles in the x- and y- directions, respectively. W and H are not more than 20.

There are H more lines in the data set, each of which includes W characters. Each character represents the color of a tile as follows.

'.' - a black tile
'#' - a red tile
'@' - a man on a black tile(appears exactly once in a data set)
 

Output
For each data set, your program should output a line which contains the number of tiles he can reach from the initial tile (including itself).
 

Sample Input
6 9....#......#..............................#@...#.#..#.11 9.#..........#.#######..#.#.....#..#.#.###.#..#.#..@#.#..#.#####.#..#.......#..#########............11 6..#..#..#....#..#..#....#..#..###..#..#..#@...#..#..#....#..#..#..7 7..#.#....#.#..###.###...@...###.###..#.#....#.#..0 0
 

Sample Output
4559613
 
#include<iostream>#include<string.h>#include<stdio.h>using namespace std;int direct[4][2] = { -1, 0, 1, 0, 0, 1, 0, -1 };  /*定义方向, 左右,上下*/char map[21][21];               /*输入的字符串*/bool mark[21][21];              /*标记走过的路程*/bool flag;int W, H;int Dx, Dy;            //记录起始位置@,从这里开始进行搜索int ans;                //记录满足的个数。初始化为1,因为@也包含在内/*****底下是核心算法,主要是从上下左右这四个方向进行搜索,注意满足搜索的条件是不能越界,不能是#,还有就是没有搜索过的--》主要是靠mark[i][j]来实现*******/void DFS( int x, int y ){    mark[x][y] = true;    for( int k = 0; k < 4; k ++ )    {        int p = x + direct[k][0];        int q = y + direct[k][1];        if( p >= 0 && q >= 0 && p < H && q < W && !mark[p][q] && map[p][q] != '#' )        {            ans ++;            DFS( p, q );        }    }    return;}int main(){    int i, j, k;    while( cin >> W >> H && ( W || H ) )   // W -> column, H -> row;    {        memset( mark, false, sizeof( mark ) );        for( i = 0; i < H; i ++ )            for( j = 0; j < W; j ++ )            {                cin >> map[i][j];                if( map[i][j] == '@' )                {                    Dx = i;                    Dy = j;                }            }        ans = 1;        DFS( Dx, Dy );        cout << ans << endl;    }}